
open List
open Util

let unitM a cont = cont a

let (>>=) = fun f1 f2 cont -> 
  f1 (fun a -> f2 a cont)

let (>>) = fun m k -> m >>= fun _ -> k	     (* may be dangerous (in ML) *)

let mapM f xs =
  let rec mapM' bag = function
    | []    -> unitM (rev bag) 
    | x::xs -> f x >>= fun x' ->
		 mapM' (x'::bag) xs
  in mapM' [] xs

let consM x xs = unitM (x::xs)

let rec iterM fM = function
  | []    -> unitM ()
  | x::xs -> fM x >>= fun _ -> iterM fM xs

let ignoreM fM = fM >> unitM ()

let runM fM x =
  fM x return
