{
open Lexer_types
}

rule scan = parse
	"<B>"				{ Open_token(B_tag) }
|	"<EM>"				{ Open_token(EM_tag) }
|	"<I>"				{ Open_token(I_tag) }
|	"<PL>"				{ Open_token(PL_tag) }
|	"<S>"				{ Open_token(S_tag) }
|	"<TT>"				{ Open_token(TT_tag) }
|	"<U>"				{ Open_token(U_tag) }
|	"<0>"				{ Open_token(Size_tag(0)) }
|	"<1>"				{ Open_token(Size_tag(1)) }
|	"<2>"				{ Open_token(Size_tag(2)) }
|	"<3>"				{ Open_token(Size_tag(3)) }
|	"<4>"				{ Open_token(Size_tag(4)) }
|	"<5>"				{ Open_token(Size_tag(5)) }
|	"<6>"				{ Open_token(Size_tag(6)) }
|	"<7>"				{ Open_token(Size_tag(7)) }
|	"<8>"				{ Open_token(Size_tag(8)) }
|	"<9>"				{ Open_token(Size_tag(9)) }
|	"<r>"				{ Open_token(Color_tag(Red)) }
|	"<g>"				{ Open_token(Color_tag(Green)) }
|	"<b>"				{ Open_token(Color_tag(Blue)) }
|	"<c>"				{ Open_token(Color_tag(Cyan)) }
|	"<m>"				{ Open_token(Color_tag(Magenta)) }
|	"<y>"				{ Open_token(Color_tag(Yellow)) }
|	"<k>"				{ Open_token(Color_tag(Black)) }
|	"<w>"				{ Open_token(Color_tag(White)) }
|	"</B>"				{ Close_token(B_tag) }
|	"</EM>"				{ Close_token(EM_tag) }
|	"</I>"				{ Close_token(I_tag) }
|	"</PL>"				{ Close_token(PL_tag) }
|	"</S>"				{ Close_token(S_tag) }
|	"</TT>"				{ Close_token(TT_tag) }
|	"</U>"				{ Close_token(U_tag) }
|	"</0>"				{ Close_token(Size_tag(0)) }
|	"</1>"				{ Close_token(Size_tag(1)) }
|	"</2>"				{ Close_token(Size_tag(2)) }
|	"</3>"				{ Close_token(Size_tag(3)) }
|	"</4>"				{ Close_token(Size_tag(4)) }
|	"</5>"				{ Close_token(Size_tag(5)) }
|	"</6>"				{ Close_token(Size_tag(6)) }
|	"</7>"				{ Close_token(Size_tag(7)) }
|	"</8>"				{ Close_token(Size_tag(8)) }
|	"</9>"				{ Close_token(Size_tag(9)) }
|	"</r>"				{ Close_token(Color_tag(Red)) }
|	"</g>"				{ Close_token(Color_tag(Green)) }
|	"</b>"				{ Close_token(Color_tag(Blue)) }
|	"</c>"				{ Close_token(Color_tag(Cyan)) }
|	"</m>"				{ Close_token(Color_tag(Magenta)) }
|	"</y>"				{ Close_token(Color_tag(Yellow)) }
|	"</k>"				{ Close_token(Color_tag(Black)) }
|	"</w>"				{ Close_token(Color_tag(White)) }
|	[^' ' '\t' '\n' '\r' '<' '>']+	{ Text_token(Lexing.lexeme lexbuf) }
|	[' ' '\t' '\n' '\r']+		{ WS_token(Lexing.lexeme lexbuf) }
|	eof				{ EOF }
