open Util
open Debug
open Lexer_simp
open Context
open Parser
open Little_simplifier
open Optimizer

open Sys
open Unix 

let main () =
  ignore (signal sigusr1 Signal_ignore);
  let lexbuf = Lexing.from_channel Pervasives.stdin in
  let _ = debugOutputString "before lexing...\n" in
  let data_simplified = lexbuf_to_tokenlist lexbuf in
  let _ = debugOutputString "before parsing...\n" in
  let parsed = buildtree data_simplified in
  let _ = debugOutputString "before littlesimp ...\n" in
  let simplified = Node(true,[],[littlesimplifier root_context parsed]) in
  let _ = debugOutputString "before even_more_simp ...\n" in
  let even_more_simplified = matcher simplified in 
    emitTree even_more_simplified

let _ = main()
let _ = exit 0
